;
;	shell for camera matrix builder
;
;


	.macro 		melt	num
	
;	XY
	mul.xy		w2t[\num],camc,w2cam[\num]

;	Z	
	mul.z		acc,w2cam[\num],camc[w]		  ; B*z+ A*w
	madd.z		w2t[\num],camc,w2cam[\num][w]

;	W
	mul.w		w2t[\num],vf00,w2cam[\num][z]	  ; .w = z
	
	sq		w2t[\num],d_world2telly+\num(vi00)
	.endm





;-- camYup is 0,1,0
	max		ONE,vf00,vf00[w]

	move.xyz	camYup,vf00
	add.y		camYup,vf00,vf00[w]	

;
	
	lq.xyz		camLookAt,d_cameraLookAt(vi00)
	lq.xyz		camLoc,d_cameraLocation(vi00)

; camera look in Z from loc to look at

	sub.xyz		camZahead,camLookAt,camLoc

	cross		camXleft,camYup,camZahead
	cross		camYup,camZahead,camXleft

	normalise_qx	camXleft,camXleft
	normalise_qx	camYup,camYup
	normalise_p	camZahead,camZahead

	sq.xyz		camXleft,d_cameraXLeft(vi00)
	sq.xyz		camYup,d_cameraYUp(vi00)
	sq.xyz		camZahead,d_cameraZAhead(vi00)


; 	we have 
;	baby - we have to transpose the matrix

	move.x		w2cam[0],camXleft
	add.y		w2cam[0],vf00,camYup[x]
	add.z		w2cam[0],vf00,camZahead[x]
	
	add.x		w2cam[1],vf00,camXleft[y]
	move.y		w2cam[1],camYup
	add.z		w2cam[1],vf00,camZahead[y]
	
	
	add.x		w2cam[2],vf00,camXleft[z]
	add.y		w2cam[2],vf00,camYup[z]
	move.z		w2cam[2],camZahead


	sub.w		w2cam[0],vf00,vf00
	sub.w		w2cam[1],vf00,vf00
	sub.w		w2cam[2],vf00,vf00
	move.w		w2cam[3],vf00

	mul.xyz		acc,w2cam[0],camLoc[x]
	madd.xyz	acc,w2cam[1],camLoc[y]
	madd.xyz	w2cam[3],w2cam[2],camLoc[z]

	sub.xyz		w2cam[3],vf00,w2cam[3]

	sq		w2cam[0],d_world2cam(vi00)
	sq		w2cam[1],d_world2cam+1(vi00)
	sq		w2cam[2],d_world2cam+2(vi00)
	sq		w2cam[3],d_world2cam+3(vi00)


	lq.x		eye_dist,d_fcontrolData(vi00)
	lq		camc,i_camConsts(vi00)	       	; Sx,Sy,A,B
	mul.xy		camc,camc,eye_dist[x]
	sub.xy		camc,vf00,camc			; -Sxh,-Syh,A,B

	sq		camc,d_camLocal(vi00)

; have to build world2telly

	melt	0
	melt	1
	melt	2
	melt	3




